
class KHMBase expands Mutator config(MonsterHunt2v1);

#exec AUDIO IMPORT FILE="Sounds\HitsoundEnemy.wav" NAME="HitsoundEnemy" GROUP="QFeedback"
#exec AUDIO IMPORT FILE="Sounds\QFeedbackArmourWav.wav" NAME="QFeedbackArmourWav" GROUP="QFeedback"
#exec AUDIO IMPORT FILE="Sounds\HitsoundTeam.wav" NAME="HitsoundTeam" GROUP="QFeedback"

var bool Initialized;
var int AmpCount;
var int kakuCount;
var int HealthCount;
var bool bFirstBlood;


var config int AmpSpawnTime;
var config int DeemerSpawnTime;
var config int HealthAwardTime;
var config bool bUseRandomWeapon;
var config int HealthRegenPerSec;
var config int MaxHealth;
var config bool bUseRegenAmmo;
var config int AmmoInterval;    // One is really low interval so ammo loads fast Ten is slow twenty is dog slow
var config bool bUseRegenHealth;
var config bool bGiveArmor;
var config int MaxRegenHealth;
var config int HealthRegenPerKill;
var config bool bUseKHMTimer;
var config bool bUseMonsterHUD;
var config int DefaultHealth;
var config bool bUseAntiBoost;
var config bool bGhostCarcass;
var config bool bHitsounds;
var config bool bAltScoring;
var config bool bCheckMonsterAttack;
var config bool stopPlayerCollision;
var config bool replaceinvis;
var config String bServerInfo;
var config float HitVolume;
var config bool VisibleMonsterEnds;
var config bool DoubleJump;
var config bool GiveAllWeapons;
var config float retainScoreOnDeathPercent;
var config bool bDropWeaponsOnDeath;
var config bool UseMHTranslocator;

var string version;
var float LastMonsterAttackTime;

var String KHMNaliFruit;
var String KHMMedBox;
var String KHMHealthPack;
var String KHMUnrealHealth;
var String KHMHealthVial;
var String KHMShieldBelt;
var String KHMUDamage;
var String KHMJumpBoots;

var config int maxJumps;  // For double jump settings if enabled
var config int jumpType;
var config float jumpHeight;

var bool bHaveQueenDests; // Check for QueenDest in map

var() globalconfig bool bUseSpawnProt; //Spawn protection
var() globalconfig int SpawnProtDuration;

var config bool bFixCrushingMover;

function PreBeginPlay()
{
local NavigationPoint NP;

    NP = Level.NavigationPointList;

    while (!bHaveQueenDests && NP != None) // Check to see if the queen needs a fix
    {
        if (QueenDest(NP) != None)
            bHaveQueenDests = True;
            
        NP = NP.nextNavigationPoint;
    }
}

function PostBeginPlay()
{
        local string newhud;
	local class newclass;

	if (Initialized)
		return;

	Log("*** ");
	Log("*** MonsterHunt2v1 mutator is locked and loaded ");
	Log("*** ");


	Initialized = True;
	kakuCount = 0;
	HealthCount = 0;
	if(DefaultHealth < 1)
		DefaultHealth = 100;
	if(bUseKHMTimer)
		SetTimer(1, True);
	if(bUseMonsterHUD)
		Level.Game.HUDType = class'KHMHUD';
	Level.Game.ScoreBoardType=Class'KHMScoreBoard';
	Level.Game.RegisterDamageMutator(Spawn(class'SpawnProt'));
        Level.Game.RegisterDamageMutator(Self);

	TournamentGameInfo(Level.Game).GameName = (Level.Game.Default.GameName@" @"@bServerInfo);

	// fix mover
	fixmover();
	if(VisibleMonsterEnds)
	{
 	   fixmymonsterend();
	}

	if ( NextMutator != None )
		NextMutator.PostBeginPlay();

}

function fixmover()
{
// light fix
	local mover M;
	foreach AllActors( class 'Mover', M)
	{
	     if(bFixCrushingMover)
                {
		   if(M.bTriggerOnceOnly && M.MoverEncroachType == ME_ReturnWhenEncroach)
		      {
			//log("Fixed this mover to not crush players in the map:"@M.name);
			M.MoverEncroachType = ME_IgnoreWhenEncroach;
		      }
		}
	     if(M.bUseTriggered == True)
		{
			//log("Fixed this mover to not be cheated by grab command:"@M.name);
			M.bUseTriggered = False;
		}
	}
}

function fixmymonsterend()
{
// fix for the monster end trigger to be visible in any map
	local MonsterEnd T;
	foreach AllActors( class 'MonsterEnd', T)
	{
            if(T.bHidden == True)
		{
			T.bHidden = False;
		}
	}
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
        if (Other.isA('Weapon') && Other.Instigator != None && Other.Instigator.IsA('ScriptedPawn'))
	{
		return true;
	}
        if(Other.IsA('Pickup'))
	{
			Pickup(Other).bAutoActivate=True;
	}
	if(Other.IsA('NaliFruit') && !Other.IsA('KHMNaliFruit'))
	{
			ReplaceWith(Other,KHMNaliFruit);
				return false;
	}
	if(Other.IsA('MedBox') && !Other.IsA('KHMMedBox'))
	{
			ReplaceWith(Other,KHMMedBox);
			return false;
	}
	if(Other.IsA('SuperHealth') || Other.IsA('HealthPack') && !Other.IsA('KHMHealthPack') && !Other.IsA('BHealthPack') && !Other.IsA('KHMUnrealHealth'))
	{
			ReplaceWith(Other,KHMHealthPack);
			return false;
	}
	if(Other.IsA('Health') && !Other.IsA('KHMHealthPack') && !Other.IsA('KHMUnrealHealth') && !Other.IsA('SuperHealth') && !Other.IsA('KHMNaliFruit'))
	{
			ReplaceWith(Other,KHMUnrealHealth);
			return false;
	}
	if(Other.IsA('HealthVial') && !Other.IsA('KHMHealthVial'))
	{
			ReplaceWith(Other,KHMHealthVial);
				return false;
	}
        if(Other.IsA('Carcass'))
        {
              if(bGhostCarcass)
              {
                        Other.Style = STY_Translucent;
                                return True;
              }
        }
	if(Other.IsA('Flashlight') && !Other.IsA('LimeLight'))
	{
              		ReplaceWith(Other,"MonsterHunt2v1.LimeLight");
				return false;
	}
	if(Other.IsA('JumpBoots') && !Other.IsA('KHMJumpBoots'))
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMJumpboots");
				return false;
	}
	if(Other.IsA('UT_JumpBoots') && !Other.IsA('KHMJumpBoots'))
	{
	    if(InStr ( Level.Title, "Andromeda" ) == -1)  //Stupid hack to let the people play with the everlasting jump boots
                    {
                      ReplaceWith(Other,"MonsterHunt2v1.KHMJumpBoots");
				return false;
                    }
        }

	if(Other.IsA('ShieldBelt') && !Other.IsA('KHMShieldBelt'))
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMShieldBelt");
				return false;
	}

	if(Other.IsA('UT_ShieldBelt') && !Other.IsA('KHMShieldBelt'))
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMShieldBelt");
				return false;
	}
	if(Other.IsA('ThighPads') && !Other.IsA('KHMThighPads'))
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMThighPads");
				return false;
	}
        if(Other.IsA('QuadShot')) //Quad has buggy graphics
	{
			ReplaceWith(Other,"Botpack.UT_FlakCannon");
				return false;
	}
	if(replaceinvis)
	{
	 if(Other.IsA('Invisibility') || Other.IsA('UT_invisibility'))
             {
                   ReplaceWith(Other,KHMMedBox);
                                return false;
             }
        }
	if(Other.IsA('SCUBAgear') && !Other.IsA('KHMSCUBA') )
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMSCUBA");
				return false;
	}
	if(Other.IsA('WarHeadLauncher') && !Other.IsA('KHMWarHeadLauncher'))
	{
	                ReplaceWith(Other,"MonsterHunt2v1.KHMWarHeadLauncher");
	                        return false;
	}
	if(Other.IsA('Armor2') && !Other.IsA('KHMArmor2'))
	{
			ReplaceWith(Other,"MonsterHunt2v1.KHMArmor2");
				return false;
	}
	if(Other.IsA('TournamentHealth') && !Other.IsA('BP_Health') && !Other.IsA('MedBox') && !Other.IsA('HealthPack') && !Other.IsA('HealthVial') && !Other.IsA('KHMHealthPack') && !Other.IsA('KHMHealthVial') && !Other.IsA('KHMMedBox'))
	{
			ReplaceWith(Other,"BPSE.BP_Health"); // BPSE taiou.
				return false;
	}

        if ( Other.IsA('Weapon') )
        {
		if ( Other.IsA('TournamentWeapon') )
			return true;

		if ( Other.IsA('UIWeapon') )
			return true;
		if ( Other.IsA('Stinger'))
		{
			ReplaceWith(Other, "MonsterHunt.OLStinger");
			return false;
		}

		if ( Other.IsA('Rifle'))
		{
			ReplaceWith( Other, "MonsterHunt.OLRifle" );
			Return false;
		}
	
		if ( Other.IsA('Razorjack') )
		{
			ReplaceWith(Other, "MonsterHunt.OLRazorjack");
			Return false;
		}

		if ( Other.IsA('Minigun'))
		{
			ReplaceWith( Other, "MonsterHunt.OLMinigun" );
			return false;
		}
	
		if ( Other.IsA('AutoMag'))
		{
			ReplaceWith( Other, "MonsterHunt.OLAutoMag" );
			return false;
		}

		if ( Other.IsA('Eightball'))
		{
			ReplaceWith( Other, "MonsterHunt.OLEightball" );
			return false;
		}
	
		if ( Other.IsA('FlakCannon') )
		{
			ReplaceWith( Other, "MonsterHunt.OLFlakCannon" );
			return false;
		}
		
		if ( Other.IsA('ASMD'))
		{
			ReplaceWith( Other, "MonsterHunt.OLASMD" );
			return false;
		}

		if ( Other.IsA('GesBioRifle') )
		{
			ReplaceWith( Other, "MonsterHunt.OLGESBioRifle" );
			return false;
		}

		if ( Other.IsA('dispersionpistol') )
		{
			ReplaceWith( Other, "MonsterHunt.OLDPistol" );
			return false;
		}

      	}
  bSuperRelevant = 0;
  return true;
}



function GiveAmp(Pawn PlayerPawn)
{
	local UDamage damage;

	if( (PlayerPawn.FindInventoryType(class'UDamage') != None) ||
		(PlayerPawn.Health <= 0) )
		return;
	damage = spawn(class'UDamage',PlayerPawn,,PlayerPawn.Location);
	if( damage != None )
	{
		damage.RespawnTime = 0.0;
		damage.GiveTo(PlayerPawn);
		damage.Activate();
       	}
}

function MutatorTakeDamage (out int ActualDamage,Pawn Victim,Pawn InstigatedBy,out Vector HitLocation,out Vector Momentum,name DamageType)
{
	local Pawn P;

	if(DamageType == 'Impact') // hammer x5 ii !
	{
	   ActualDamage *= 5;
	}
        // This will remove all player-on-player damage as well as self-damage
	if(bUseAntiBoost)
	{
	    if(Victim != None && InstigatedBy != None)
	       {
                  if (InstigatedBy.IsA('PlayerPawn') && Victim.IsA('PlayerPawn'))
		     {
			Momentum = Vect(0,0,0);
                        ActualDamage = 0;
                        // Hack to remove redeemer shockwave from moving you
                        if (string(DamageType)=="RedeemerDeath")
                           {
			      Velocity = Vect(0,0,0);
			      Victim.Velocity = (Victim.Velocity * 0);
                           }
                     }
		}
	}
	if(bHitsounds) // hitsounds code
	{
               if ( InstigatedBy.IsA('PlayerPawn') && (Victim != InstigatedBy) )
	     {
		if( Victim.IsA('PlayerPawn') || Victim.IsA('Bot') )  // When player shoot other player
		   {
			PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_None, HitVolume, false);
			PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_Interface, HitVolume, false);
			PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_Interact, HitVolume, false);
		   }
		if( Victim.IsA('ScriptedPawn') )  // When player shoots a monster
		   {   	// Cows and rabbits are friends
			if(Victim.IsA('Cow')|| Victim.IsA('BabyCow')|| Victim.IsA('NaliRabbit'))
			{
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_None, HitVolume, false);
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_Interface, HitVolume, false);
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundTeam', SLOT_Interact, HitVolume, false);
			}
			else // ScriptedPawn is an enemy
			{
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundEnemy', SLOT_None, HitVolume, false);
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundEnemy', SLOT_Interface, HitVolume, false);
				PlayerPawn(InstigatedBy).PlaySound(Sound'HitsoundEnemy', SLOT_Interact, HitVolume, false);
			}
		   }
	     }
	}
	if(bAltScoring) // Scoring by damage
	{
	   if (Victim != None && InstigatedBy != None)
	      {
                 if ( Victim.IsA('ScriptedPawn') && instigatedBy.IsA('ScriptedPawn') || Victim == instigatedBy && Victim.IsA('ScriptedPawn'))
                      actualDamage=0;
                 if ( actualDamage < 0 )
                      return;
                 // Hack for controlling massive SSR/Deemer damage score
                 else if ( actualDamage > 1000 )
                      actualDamage=1000;
                 // Stop scoring above monsters health value
                 if (ActualDamage > Victim.Health)
                     ActualDamage = Victim.Health;
                 // Add the monster health taken to the players score
                 if (Victim != None && InstigatedBy != None && Victim != InstigatedBy)
	            {
	               if (Victim.IsA('ScriptedPawn') && InstigatedBy.bIsPlayer)
		          {
		             InstigatedBy.PlayerReplicationInfo.Score += ActualDamage;
	                  }
                    }
	     }
	 }
	if ( NextDamageMutator != None )
		NextDamageMutator.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);

}
function ModifyPlayer(Pawn Other)
{
	local int randm;
	local inventory inv;
	local class<DJ_InventoryItem> InventoryClass;
	local DJ_InventoryItem DJ_Inv;


	if(!Other.IsA('TournamentPlayer'))return;
	 TournamentPlayer(Other).PlayerReplicationInfo.Team = 0; // kyouseitekini team 0


	Other.Health = DefaultHealth;

        if (stopPlayerCollision == true)
        Other.bBlockPlayers = false;

        if(UseMHTranslocator)
        DeathMatchPlus(Level.Game).GiveWeapon(Other,"MonsterHunt2v1.MHTranslocator");

        // This is added inventory to allow the double jump mod to function
        InventoryClass = class<DJ_InventoryItem>(DynamicLoadObject("MonsterHunt2v1.DJ_InventoryItem", class'Class'));

        if(DoubleJump)
	   {
              DJ_Inv = Spawn(class'DJ_InventoryItem', Other,, Other.Location);
              if( DJ_Inv != None )
	         {
		    DJ_Inv.RespawnTime = 0.0;
		    DJ_Inv.GiveTo(Other);
		    DJ_Inv.maxJumps = maxJumps;
		    DJ_Inv.jumpType = jumpType;
		    DJ_Inv.jumpHeight = jumpHeight;
	         }
           }
         // Spawn protection code
         if (bUseSpawnProt)
            {
               Inv = Other.FindInventoryType(class'SpawnProtEffect');
               if ( Inv != None )
                  SpawnProtEffect(Inv).Duration = SpawnProtDuration;
               else
                  {
                     inv = Spawn(class'SpawnProtEffect');
                     if( inv != None )
                        {
                           SpawnProtEffect(Inv).Duration = SpawnProtDuration;
                           inv.GiveTo(Other);
                           inv.Activate();
                        }
                 }
            }
         // Loaded FTW!
         if(GiveAllWeapons)
            {
               GiveWeapon(Other,class'PulseGun');
	       GiveWeapon(Other,class'ShockRifle');
	       GiveWeapon(Other,class'UT_FlakCannon');
	       GiveWeapon(Other,class'Botpack.UT_BioRifle');
	       GiveWeapon(Other,class'Botpack.Minigun2');
	       GiveWeapon(Other,class'Botpack.Ripper');
	       GiveWeapon(Other,class'Botpack.UT_Eightball');
               GiveWeapon(Other,class'SniperRifle');
            }
	// random weapon
	// ges,shock,pulse,ripper,mini,flak,rocket,sniper
	if (bUseRandomWeapon && Other.IsA('TournamentPlayer') ) // players only
	{
		randm = Rand(10);
		switch(randm)
		{
			case 0:
				GiveWeapon(Other,class'UT_Biorifle');
				//Other.Health += 100;
			break;
			case 1:
				GiveWeapon(Other,class'Shockrifle');
				//Other.Health += 50;
			break;
			case 2:
				GiveWeapon(Other,class'Pulsegun');
				//Other.Health += 80;
			break;
			case 3:
				GiveWeapon(Other,class'ripper');
				//Other.Health += 110;
			break;
			case 4:
				GiveWeapon(Other,class'minigun2');
				//Other.Health += 90;
			break;
			case 5:
				GiveWeapon(Other,class'UT_Flakcannon');
				//Other.Health += 30;
			break;
			case 6:
				GiveWeapon(Other,class'UT_EightBall');
				//Other.Health += 20;
			break;
			case 7:
                                GiveWeapon(Other,class'SniperRifle');
				//Other.Health += 20;
			break;
			case 8:
				GiveWeapon(Other,class'KHMWarHeadLauncher');
				//Other.Health += 10;
			break;
			case 9:
				GiveWeapon(Other,class'ImpactHammer');
				//Other.Health += 400;
			break;
		}
		if(bGiveArmor)
		{
			inv = Spawn(class'Armor2');
			if( inv != None )
			{
				inv.bHeldItem = true;
				inv.RespawnTime = 0.0;
				inv.GiveTo(Other);
				inv.Charge = Inv.Default.Charge;
			}
		}
		Other.ReceiveLocalizedMessage( class'KHMGetWeaponMessage', randm, Other.PlayerReplicationInfo, Other.PlayerReplicationInfo );
	}

	if ( NextMutator != None )
		NextMutator.ModifyPlayer(Other);
}

function GiveWeapon(Pawn PlayerPawn, class<TournamentWeapon> WeaponClass )
{
	local Weapon NewWeapon;

	if( PlayerPawn.FindInventoryType(WeaponClass) != None )
		return;
	newWeapon = Spawn(WeaponClass);
	if( newWeapon != None )
	{
		newWeapon.RespawnTime = 0.0;
		newWeapon.GiveTo(PlayerPawn);
		newWeapon.bHeldItem = true;
		newWeapon.SetSwitchPriority(PlayerPawn);
		newWeapon.WeaponSet(PlayerPawn);
		newWeapon.AmbientGlow = 0;
		PlayerPawn.PendingWeapon = None;
		if ( !newWeapon.IsA('ImpactHammer') && !newWeapon.IsA('Translocator') )
                {
			newWeapon.GiveAmmo(PlayerPawn);
			newWeapon.AmmoType.AmmoAmount = newWeapon.AmmoType.MaxAmmo;
		}
	}
}

function ScoreKill(Pawn Killer, Pawn Other)
{
	if(Killer == None)return; // sui
	if(!Killer.bIsHuman)return; // bot iran
	if(Killer.PlayerReplicationInfo.bIsABot) return; // bot irane-
	if(Killer.IsA('ScreptedPawn'))return;
	if(Killer.IsA('ScreptedPawn') && Other.IsA('ScreptedPawn'))return;
	if ( (Killer == None) && (Other == None) )return; // ?
	if ( Killer.bIsPlayer && Other.bIsPlayer )return; // tk
	if ( Other.Spree > 1 && Other.bIsPlayer)
		EndSpree(Killer, Other);
	if(Other.bIsPlayer)Other.Spree = 0;
		if ( (Killer != None) && Killer.bIsPlayer && (Killer != Other) )
		{
			//if(Killer.Health <= MaxHealth)Killer.Health += Rand(HealthRegenPerKill)+HealthRegenPerKillMin;
			if(Killer.Health <= MaxHealth)
                           {
                              Killer.Health += HealthRegenPerKill;
                           }
			if(Killer.Health > MaxHealth)          //New check for max health
                           {
                             Killer.Health = MaxHealth;
                           }
			Killer.Spree+=1;
			if ( Killer.Spree > 14 )
				NotifySpree(Killer, Killer.Spree);

			if ( (TournamentPlayer(Killer).Level.TimeSeconds - TournamentPlayer(Killer).LastKillTime < 3))
			{
				TournamentPlayer(Killer).MultiLevel++;
				if(TournamentPlayer(Killer).MultiLevel >= 41)TournamentPlayer(Killer).MultiLevel = 40;
				TournamentPlayer(Killer).ReceiveLocalizedMessage( class'KHMMultiKillMessage', TournamentPlayer(Killer).MultiLevel );
				CheckBroadCast(Killer,TournamentPlayer(Killer).MultiLevel);
			}
			else
				TournamentPlayer(Killer).MultiLevel = 0;

			TournamentPlayer(Killer).LastKillTime = TournamentPlayer(Killer).Level.TimeSeconds;
		}
}

function CheckBroadCast(Pawn Killer,int num)
{
	if(Killer.bIsPlayer && !Killer.PlayerReplicationInfo.bIsABot)
	BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName@GetText(num));
}

function string GetText(int Switch)
{
	switch (Switch)
	{
		case 1:
			return " has Double Kill!";
			break;
		case 2:
			return " has Multi Kill!";
			break;
		case 3:
			return " has Mega Kill!";
			break;
		case 4:
			return " has ULTRA KILL!!";
			break;
		case 5:
			return " has M O N S T E R  K I L L !!!";
			break;
		case 6:
			return " has L U D I C R O U S  K I L L !!!!";
			break;
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:
		case 16:
		case 17:
		case 18:
		case 19:
		case 20:
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27:
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		        return " has H  O  L  Y   S  H  I  T !!!!!!!";
			break;
		case 40:
			return " is still going.... !!!!!!!!!!!";
			break;
	}
	return "";
}
function NotifySpree(Pawn Other, int num)
{
	local Pawn P;

	if ( num == 30 )
		num = 0;
	else if ( num == 45 )
		num = 1;
	else if ( num == 60 )
		num = 2;
	else if ( num == 90 )
		num = 3;
	else if ( num == 125 )
		num = 4;
	else if ( num == 250 )
		num = 5;
	else
		return;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.IsA('TournamentPlayer') )
			P.ReceiveLocalizedMessage( class'KHMKillingSpreeMessage', Num, Other.PlayerReplicationInfo );
}


function EndSpree(Pawn Killer, Pawn Other)
{
	local Pawn P;

	if ( !Other.bIsPlayer || Killer.PlayerReplicationInfo.bIsABot)
		return;
	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	if ( P.IsA('TournamentPlayer') )
	{
		if(Other.IsA('ScriptedPawn'))
			P.ReceiveLocalizedMessage( class'KHMKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo,  Killer.PlayerReplicationInfo );
		else
			P.ReceiveLocalizedMessage( class'KHMKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo );
	}
}

function bool PreventDeath (Pawn Killed, Pawn Killer, name DamageType, Vector HitLocation)
{
	local bool pd;

    pd=Super.PreventDeath(Killed,Killer,DamageType,HitLocation);

    // Pinata effect, all weapons dropped on death
    if (Killed != none && !pd) {
    	if (Killer != none && Killer.IsA('ScriptedPawn'))
    		DiscardInventory(Killed);

    	if (Killed.bIsPlayer)
            Killed.PlayerReplicationInfo.Score *= retainScoreOnDeathPercent;
    }
	return pd;
}

function DiscardInventory (Pawn Other)
{
	local Actor dropped;
	local Inventory Inv;
    local class<Weapon> Initial1;
    local class<Weapon> Initial2;

    if (Other != none)
    {
    	if ( Other.DropWhenKilled != None )
    	{
    		dropped=Spawn(Other.DropWhenKilled,,,Other.Location);
    		Inv=Inventory(dropped);
    		if ( Inv != None )
    		{
    			Inv.RespawnTime=0.00;
    			Inv.BecomePickup();
    		}
    		if ( dropped != None )
    		{
    			dropped.RemoteRole=ROLE_DumbProxy;
    			dropped.SetPhysics(PHYS_Falling);
    			dropped.bCollideWorld=True;
    			dropped.Velocity=Other.Velocity + VRand() * 280;
    		}
    		if ( Inv != None )
    		{
    			Inv.GotoState('Pickup','dropped');
    		}
    	}

        Inv=Other.Inventory;
    JL0111:
    	if ( Inv != None )
    	{
    		if ( Inv.IsA('Weapon') )
    		{
    			if ( (Inv.Class != Level.Game.BaseMutator.MutatedDefaultWeapon()) && ((Weapon(Inv).AmmoType == None) || (Weapon(Inv).AmmoType.AmmoAmount > 0)) && Weapon(Inv).bCanThrow)
    			{
                           if (Inv.class != class'Enforcer' && Inv.Class != class'DoubleEnforcer')
                    	   DropWeapon(Other,Inv);
    			}
    		}
    		Inv.Destroy();
    		Inv=Inv.Inventory;
    		goto JL0111;
    	}
   	}
}

function DropWeapon (Pawn Other, Inventory Inv)
{
	local Inventory DropInv;
	local int DropPitch;
	local int DropYaw;
	local Rotator DropRot;

	DropInv=Spawn(Inv.Class,,,Other.Location);
	if ( DropInv == None )
	{
		return;
	}
	DropRot=Other.ViewRotation;
	DropPitch=Rand(32768);
	DropYaw=Rand(65536);
	DropRot.Pitch=DropPitch;
	DropRot.Yaw=DropYaw;
        Weapon(DropInv).bWeaponStay = false;
	DropInv.Velocity=vector(DropRot) * (Rand(250) + 250);
	DropInv.RespawnTime=0.00;
	DropInv.BecomePickup();
	DropInv.NetPriority=2.50;
	DropInv.RemoteRole=ROLE_DumbProxy;
	DropInv.SetPhysics(PHYS_Falling);
	DropInv.bCollideWorld=True;
	DropInv.GotoState('Pickup','dropped');
}

simulated function Tick (float DT)
{
    Super.Tick(DT);

    if ( Level.Game.bGameEnded ) return;

    if ((bCheckMonsterAttack) && (LastMonsterAttackTime < Level.TimeSeconds)) // call every x secs
        MonsterAttackCheck();
}

function Timer()
{

	// regenerate ammo (except redeemer) & health in one fell swoop
	local Pawn P;
	local Inventory Inv;
	local skaarjtrooper sp;
	
	//foreach AllActors( class 'skaarjtrooper', sp)
	// redone for faster iteration. ForEach function replaced here
	// SkaarjTrooper declared to remove the unkillable trooper
	for (P=Level.PawnList; P!=None; P=P.NextPawn)
	{
	   sp=skaarjtrooper(P);
           if (sp !=None)
           {
              //log("found one:"@sp);
              if(sp.weapontype==none)
              GiveWeapon(sp,Class'botpack.minigun2');
              //log("gave weapon to:"@sp);
              if (sp.weapon !=none)
              sp.weapon.bCanThrow=False;
           }
        }

	if (AmpCount < AmpSpawnTime)AmpCount++;

	else if (AmpCount == AmpSpawnTime)
        {

		BroadcastLocalizedMessage( class'KHMAmpMessage',,, None, None );

		// give all current players damage amps
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
			if ( P.IsA('Bot')  || P.IsA('TournamentPlayer'))
				GiveAmp(P);

		AmpCount = 0;
	}
	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.IsA('Bot')  || P.IsA('TournamentPlayer'))
                {
			if (P.Health > 0)
                        {
				if(bUseRegenAmmo)
				{
				for( Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory )
					if ( (Ammo(Inv)!=None) && (P.bFire==0) && (P.bAltFire==0) )
						if (Ammo(Inv).AmmoAmount < Ammo(Inv).MaxAmmo * 10) {
							Ammo(Inv).AmmoAmount += (Ammo(Inv).Default.AmmoAmount/ AmmoInterval);
							if (Ammo(Inv).AmmoAmount > Ammo(Inv).MaxAmmo * 10)
								Ammo(Inv).AmmoAmount = Ammo(Inv).MaxAmmo * 10;
						}
				}
				if(bUseRegenHealth)
				{
				// health
				if ( P.Health < MaxRegenHealth && !P.Region.Zone.bWaterZone)       // waterzone stoppage of health regen
					//P.Health = FMin(MaxRegenHealth, P.Health + Rand(HealthRegenPerSec)+HealthRegenPerSecMin);
					P.Health = FMin(MaxRegenHealth, P.Health + HealthRegenPerSec);
				}
			}
               }

 //random Trans & health

    P = GetRandomPlayer();
    if(P != None)
    {
        if (kakuCount < DeemerSpawnTime)kakuCount ++;
  	if (HealthCount < HealthAwardTime)HealthCount ++;

        if(DeemerSpawnTime-kakuCount < 5 &&  DeemerSpawnTime-kakuCount > 0)
        {
         BroadcastLocalizedMessage(class'KHMRandomTransMsg',DeemerSpawnTime-kakuCount,P.PlayerReplicationInfo  );
        }

	if(HealthAwardTime-HealthCount < 5 && HealthAwardTime-HealthCount > 0)
	{
   	 BroadcastLocalizedMessage(class'KHMRandomHealthMsg',HealthAwardTime-HealthCount,P.PlayerReplicationInfo  );
   	}
        if (kakuCount >= DeemerSpawnTime)
        {
   	     kakuCount = 0;
             P = GetRandomPlayer();
             if(P.bIsPlayer)
             {
               BroadcastLocalizedMessage(class'KHMRandomTransMsg',kakuCount,P.PlayerReplicationInfo  );
               GiveRedeemer(P);
             }
        }
        if (HealthCount >= HealthAwardTime)
        {
	     HealthCount = 0;
             P = GetRandomPlayer();
             if(P.bIsPlayer)
             {
               BroadcastLocalizedMessage(class'KHMRandomHealthMsg',HealthCount,P.PlayerReplicationInfo  );
               GiveHealth(P);
             }
	}
    }
}

function GiveRedeemer(Pawn PlayerPawn)
{
	local KHMWarheadlauncher  rede;
	rede= spawn(class'KHMWarHeadLauncher');
	if( rede!= None )
	{
           rede.RespawnTime = 0.0;
           rede.GiveTo(PlayerPawn);
           rede.SetSwitchPriority(PlayerPawn);
           PlayerPawn.AddInventory(rede);
           rede.PickupAmmoCount = 1;
	   rede.GiveAmmo(PlayerPawn);
	}
}

function MonsterAttackCheck()
{
    local ScriptedPawn S;
    local Queen Q;
    local Pawn P;

    for ( P=Level.PawnList; P!=None; P=P.nextPawn )
    {
        S = ScriptedPawn(P);
        Q = Queen(P);
        
        if (S != None && S.Enemy != None && S.Enemy.IsA('ScriptedPawn'))
        {
            S.Hated = None;
            S.Enemy = None;
            if (S.OldEnemy!=None && S.OldEnemy.IsA('ScriptedPawn'))
                S.OldEnemy = none;
            S.WhatToDoNext('Waiting','');
        }
        // Dirty fix for the teleport looping queen
        if (!bHaveQueenDests)
        {
            Q = Queen(P);
            
            if (Q != none)
            {
                if (Q.IsInState('Teleporting'))
                Q.GotoState('Attacking');
            }
        }
    }
    
    LastMonsterAttackTime = Level.TimeSeconds;
}

function GiveHealth(Pawn PlayerPawn)
{
	PlayerPawn.Health+=500;
}

function Pawn GetRandomPlayer()
{
  local Pawn N;
  local PlayerPawn Dest;
  local Pawn Candidate[32];
  local int num;

  for (N=Level.PawnList; N!=None; N=N.NextPawn)
  {
    Dest=PlayerPawn(N);
    if (Dest!=None && Dest.bIsPlayer && !Dest.PlayerReplicationInfo.bIsSpectator)
    {
      if (num<32) Candidate[num] = Dest;
      else if (Rand(num) < 32) Candidate[Rand(32)] = Dest;
      num++;
    }
  }

  if(num==0) return None;
  return Candidate[Rand(Min(32,num))];
}

// Personal light source
function Mutate(string MutateString, PlayerPawn Sender)
{
   if(MutateString~="light")
   {
       Sender.ClientMessage("Toggling personal light on");
       Sender.AmbientGlow = 254;
       Sender.LightEffect=LE_NonIncidence;
       Sender.LightBrightness=255;
       Sender.LightHue=210;
       Sender.LightRadius=30;
       Sender.LightSaturation=200;
       Sender.LightType=LT_Steady;
   }
   if(MutateString~="dark")
   {
       Sender.ClientMessage("Toggling personal light off");
       Sender.AmbientGlow = Owner.Default.AmbientGlow;
       Sender.LightType = LT_None;
   }
   // If you use Mutate in your code ALWAYS add this next bit, else it breaks
   // other calls to mutate like mapvote
   if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);
}




defaultproperties
{
     AmpSpawnTime=400
     DeemerSpawnTime=120
     HealthAwardTime=500
     bUseRandomWeapon=True
     HealthRegenPerSec=10
     MaxHealth=500
     bUseRegenAmmo=True
     bUseRegenHealth=True
     bGiveArmor=True
     MaxRegenHealth=500
     HealthRegenPerKill=10
     bUseKHMTimer=True
     bUseMonsterHUD=True
     DefaultHealth=500
     bUseAntiBoost=False
     bGhostCarcass=True
     AmmoInterval=3
     bHitsounds=True
     bAltScoring=True
     bCheckMonsterAttack=True
     stopPlayerCollision=True
     replaceinvis=True
     VisibleMonsterEnds=True
     GiveAllWeapons=True
     DoubleJump=True
     maxJumps=3
     jumpType=2
     jumpHeight=2.00
     bDropWeaponsOnDeath=True
     retainScoreOnDeathPercent=0.75
     bUseSpawnProt=True
     SpawnProtDuration=10
     UseMHTranslocator=True
     HitVolume=16.00
     bFixCrushingMover=False
     bServerInfo="Default message"
     version="MonsterHunt2v1 "
     KHMNaliFruit="MonsterHunt2v1.KHMNaliFruit"
     KHMMedBox="MonsterHunt2v1.KHMMedBox"
     KHMHealthPack="MonsterHunt2v1.KHMHealthPack"
     KHMUnrealHealth="MonsterHunt2v1.KHMUnrealHealth"
     KHMHealthVial="MonsterHunt2v1.KHMHealthVial"
}
